## freeorion 0.4.8

=== CMakeLists.txt ===
if(APPLE)
    cmake_minimum_required(VERSION 3.4 FATAL_ERROR)
else()
    cmake_minimum_required(VERSION 3.1 FATAL_ERROR)
endif()

cmake_policy(SET CMP0042 NEW)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_HOME_DIRECTORY}/cmake ${CMAKE_HOME_DIRECTORY}/GG/cmake)
set(CMAKE_OSX_DEPLOYMENT_TARGET 10.9 CACHE STRING "Set the minimum OSX deployment target version")
set(CMAKE_OSX_ARCHITECTURES x86_64 CACHE STRING "Set the architecture the universal binaries for OSX should be built for")

IF(CMAKE_GENERATOR STREQUAL "Xcode")
  set(CMAKE_CONFIGURATION_TYPES Release)
ELSE()
  set(CMAKE_CONFIGURATION_TYPES Debug Release)
ENDIF()
IF(NOT CMAKE_BUILD_TYPE)
  MESSAGE(STATUS "Setting build type to 'Release' as none was specified.")
  SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  SET_PROPERTY(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
ENDIF(NOT CMAKE_BUILD_TYPE)

message(STATUS "Build type CMAKE_BUILD_TYPE set to ${CMAKE_BUILD_TYPE}")

include(UseCompilerCache)
find_compiler_cache(PROGRAM ccache)

##
## Global project configuration
##

project(FreeOrion)

use_compiler_cache_with_xcode()

include(GNUInstallDirs)
include(UseCodeCoverage)
include(TargetDependencies)

set(FreeOrion_VERSION 0.4.8)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

option(BUILD_SHARED_LIBS "Build project as shared libraries." ON)
option(BUILD_TESTING "Build the testing tree." OFF)
option(BUILD_HEADLESS "Build only headless components: server and AI." OFF)

if(BUILD_TESTING)
    message( STATUS "Building Tests")
    enable_testing()
    enable_coverage()

    if(NOT TARGET unittest)
        add_custom_target(unittest
            COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
            COMMENT "Run tests for ${CMAKE_PROJECT_NAME}"
        )
    endif()
endif()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

if(WIN32)
    # Location of the FreeOrionSDK root
    set(CMAKE_PREFIX_PATH "${CMAKE_SOURCE_DIR}/..")
    # Search dependency DLLs inside FreeOrionSDK
    target_dependencies_add_search_path("${CMAKE_PREFIX_PATH}/bin")
    set(CMAKE_INSTALL_BINDIR ".")
    set(FreeOrion_INSTALL_LIBDIR ".")
endif()

if(APPLE)
    set(FreeOrionSDK_VERSION 8)
    set(FreeOrionSDK_FILE "FreeOrionSDK_${FreeOrionSDK_VERSION}_Clang-MacOSX-10.9-x86_64.dmg")
    if(NOT EXISTS "${CMAKE_BINARY_DIR}/${FreeOrionSDK_FILE}")
	file(DOWNLOAD
            "https://github.com/freeorion/freeorion-sdk/releases/download/v${FreeOrionSDK_VERSION}/${FreeOrionSDK_FILE}"
            "${CMAKE_BINARY_DIR}/${FreeOrionSDK_FILE}"
            SHOW_PROGRESS
        )
    endif()
    set(FreeOrionSDK_INSTALL_VERSION 0)
    if(EXISTS "${CMAKE_BINARY_DIR}/dep/sdkversion")
        file(READ "${CMAKE_BINARY_DIR}/dep/sdkversion" FreeOrionSDK_INSTALL_VERSION)
    endif()
    if(NOT "${FreeOrionSDK_VERSION}" EQUAL "${FreeOrionSDK_INSTALL_VERSION}")
        file(REMOVE_RECURSE "${CMAKE_BINARY_DIR}/dep")
        execute_process(COMMAND /usr/bin/hdiutil attach "${CMAKE_BINARY_DIR}/${FreeOrionSDK_FILE}")
        execute_process(COMMAND ${CMAKE_COMMAND} -E tar xfj /Volumes/FreeOrionSDK/dep.tar.bz2 WORKING_DIRECTORY "${CMAKE_BINARY_DIR}")
        execute_process(COMMAND /usr/bin/hdiutil detach "/Volumes/FreeOrionSDK")
        file(WRITE "${CMAKE_BINARY_DIR}/dep/sdkversion" "${FreeOrionSDK_VERSION}")
    endif()
    # Location of the FreeOrionSDK root
    set(CMAKE_PREFIX_PATH "${CMAKE_BINARY_DIR}/dep/")
    set(CMAKE_FRAMEWORK_PATH "${CMAKE_BINARY_DIR}/dep/Frameworks")
    set(CMAKE_PROGRAM_PATH "${CMAKE_FRAMEWORK_PATH}/Python.framework/Versions/Current/bin")
endif()

if(UNIX)
    set(FreeOrion_INSTALL_LIBDIR "${CMAKE_INSTALL_LIBDIR}/freeorion")
endif()

if(APPLE)
    set(CMAKE_INSTALL_RPATH
        "@loader_path/../SharedSupport"
        "@loader_path/../Frameworks"
    )
    set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
endif()

if(NOT APPLE)
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${FreeOrion_INSTALL_LIBDIR}")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()

add_compile_options(
    # Enable (almost) all warnings on compilers
    # https://gcc.gnu.org/onlinedocs/gcc/Warning-Options.html#index-Wall-316
    $<$<CXX_COMPILER_ID:GNU>:-Wall>
    # http://clang.llvm.org/docs/DiagnosticsReference.html#wall
    $<$<CXX_COMPILER_ID:Clang>:-Wall>
    # https://msdn.microsoft.com/en-us/library/thxezb7y.aspx#Anchor_1
    $<$<CXX_COMPILER_ID:MSVC>:/W4>

    # Disable "'<param>': unreferenced formal parameter" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4100>
    # Disable "'<class>::<member>': class '<member-type>' needs to have dll-interface to be used by clients of class '<class>'" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4251>
    # Disable "'<func>': unreferenced local function has been removed" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4505>
    # Disable "declaration of '<type>' hides global declaration" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4459>
    # Disable "function '<func>' marked as __forceinline not inlined" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4714>

    # Enable C++ Exception unwind mechanics with DLL support
    $<$<CXX_COMPILER_ID:MSVC>:/EHsc>
)

set_property(DIRECTORY APPEND
    PROPERTY COMPILE_DEFINITIONS
        # Set minimum Windows target version to WindowsXP
        # https://msdn.microsoft.com/en-us/library/aa383745.aspx
        $<$<PLATFORM_ID:Windows>:_WIN32_WINNT=_WIN32_WINNT_WINXP>
        # Default to unicode variants when using Win32 API
        # https://msdn.microsoft.com/en-us/library/dybsewaf.aspx
        $<$<PLATFORM_ID:Windows>:_UNICODE>
        # Disable "'<func>' was declared deprecated" warning
        # https://msdn.microsoft.com/en-us/library/ttcz0bys.aspx
        $<$<PLATFORM_ID:Windows>:_CRT_SECURE_NO_WARNINGS>
        # Disable '<func>': Function call with parameters that may be unsafe" warning
        # https://msdn.microsoft.com/en-us/library/ttcz0bys.aspx
        $<$<PLATFORM_ID:Windows>:_SCL_SECURE_NO_WARNINGS>
        # Disable '<func>': The POSIX name for this item is deprecated." warning
        # https://msdn.microsoft.com/en-us/library/ttcz0bys.aspx
        $<$<PLATFORM_ID:Windows>:_CRT_NONSTDC_NO_WARNINGS>

        # Define platform specific macros
        $<$<PLATFORM_ID:Windows>:FREEORION_WIN32>
        $<$<PLATFORM_ID:Darwin>:FREEORION_MACOSX>
        $<$<PLATFORM_ID:Linux>:FREEORION_LINUX>
        $<$<PLATFORM_ID:FreeBSD>:FREEORION_FREEBSD>
        $<$<PLATFORM_ID:OpenBSD>:FREEORION_OPENBSD>
)

if(WIN32 AND MSVC)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
endif()

if(APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -stdlib=libc++")
    set(CMAKE_ARCHIVE_LINKER_FLAGS "${CMAKE_ARCHIVE_LINKER_FLAGS} -stdlib=libc++")
endif()

if(UNIX AND NOT APPLE)
    add_definitions(-DENABLE_BINRELOC -DBINPATH=\"${CMAKE_INSTALL_FULL_BINDIR}\" -DSHAREPATH=\"${CMAKE_INSTALL_FULL_DATADIR}\")
endif()


##
## Collect project dependencies.
##

set(MINIMUM_PYTHON_VERSION 2.7)
set(MINIMUM_BOOST_VERSION 1.58.0)

find_package(Threads)
find_package(PythonInterp ${MINIMUM_PYTHON_VERSION} REQUIRED)
find_package(PythonLibs ${MINIMUM_PYTHON_VERSION} REQUIRED)
find_package(Boost ${MINIMUM_BOOST_VERSION}
    COMPONENTS
        date_time
        filesystem
        iostreams
        locale
        log
        log_setup
        regex
        serialization
        signals
        system
        thread
    REQUIRED)
if(${Boost_VERSION} GREATER 106699) # boost >= 1.67
    find_package(Boost COMPONENTS python27 REQUIRED)
    set(Boost_PYTHON_LIBRARY ${Boost_PYTHON27_LIBRARY})
else()
    find_package(Boost COMPONENTS python REQUIRED)
endif()

find_package(ZLIB REQUIRED)
if(NOT BUILD_HEADLESS)
    find_package(Freetype REQUIRED)
    find_package(OpenGL REQUIRED)

    if(NOT OPENGL_GLU_FOUND)
        message(FATAL_ERROR "OpenGL GLU library not found.")
    endif()

    find_package(SDL REQUIRED)
    find_package(OpenAL REQUIRED)
    find_package(Ogg REQUIRED)
    find_package(Vorbis REQUIRED)
endif()

if(APPLE)
    find_library(CORE_FOUNDATION_LIBRARY CoreFoundation)
    find_library(ICONV_LIBRARY iconv)
endif()

if(BUILD_TESTING)
    add_subdirectory(test)
endif()

if(NOT BUILD_HEADLESS)
    set(BUILD_DEVEL_PACKAGE OFF CACHE INTERNAL "Disables installation of GiGi development files." FORCE)
    set(_ORIG_CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR})
    set(CMAKE_INSTALL_LIBDIR "${FreeOrion_INSTALL_LIBDIR}")
    add_subdirectory(GG)
    set(CMAKE_INSTALL_LIBDIR ${_ORIG_CMAKE_INSTALL_LIBDIR})
    unset(_ORIG_CMAKE_INSTALL_LIBDIR)
endif()

set_property(DIRECTORY APPEND
    PROPERTY COMPILE_DEFINITIONS
        # Disable Boost auto-linking
        # http://www.boost.org/doc/libs/1_59_0/libs/config/doc/html/index.html#boost_config.configuring_boost_for_your_platform.user_settable_options
        BOOST_ALL_NO_LINK

        # Boost iostreams doesn't honor BOOST_ALL_NO_LINK when linking zlib.
        # It also tries to link by default to the boost in-source zlib librar,
        # which we don't want.
        # http://www.boost.org/doc/libs/1_59_0/boost/iostreams/detail/config/zlib.hpp
        $<$<PLATFORM_ID:Windows>:BOOST_ZLIB_BINARY=zlib.lib>

        # Link all boost libraries dynamically
        # http://www.boost.org/doc/libs/1_59_0/libs/config/doc/html/index.html#boost_config.configuring_boost_for_your_platform.user_settable_options
        BOOST_ALL_DYN_LINK

        # with boost 1.61 some boost::optional internals were changed. However
        # boost::spirit relies on some API the old implementation provided.
        # This define enables the usage of the old boost::optional
        # implementation.  Boost upstream tracks this bug as #12349
        $<$<AND:$<VERSION_GREATER:${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION},1.60>,$<VERSION_LESS:${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION},1.67>>:BOOST_OPTIONAL_CONFIG_USE_OLD_IMPLEMENTATION_OF_OPTIONAL>

        # We don't need localized output of Boost date_time and not setting
        # the define causes the inclusion of code, which contains std::tolower.
        # This however causes a macro substitutions caused by the libpython
        # headers, which in turn breaks the build.  Python 2.7.13 should have
        # fixed this with python bug #10910
        $<$<PLATFORM_ID:Darwin>:BOOST_DATE_TIME_NO_LOCALE>
        $<$<PLATFORM_ID:FreeBSD>:BOOST_DATE_TIME_NO_LOCALE>
)


##
## Define main project targets.
##

# To run the version generation every compile we need to deferr the
# execution to a separate target and the existing python command
add_custom_target(freeorionversion
    COMMAND
    "${PYTHON_EXECUTABLE}"
    "${CMAKE_SOURCE_DIR}/cmake/make_versioncpp.py"
    "${CMAKE_SOURCE_DIR}"
    "CMake"
)

set_source_files_properties(
    ${CMAKE_CURRENT_SOURCE_DIR}/util/Version.cpp
    PROPERTIES
    GENERATED TRUE
)

if(Apple)
    set_source_files_properties(
        "${CMAKE_CURRENT_SOURCE_DIR}/Xcode/Info.plist"
        PROPERTIES
        GENERATED TRUE
    )
endif()


add_library(freeorioncommon "")

if(WIN32)
    set_property(TARGET freeorioncommon
        PROPERTY
        OUTPUT_NAME Common
    )
endif()

target_compile_options(freeorioncommon
    PRIVATE
        $<$<CXX_COMPILER_ID:GNU>:-fvisibility=hidden>
        $<$<CXX_COMPILER_ID:Clang>:-fvisibility=hidden>
        $<$<CXX_COMPILER_ID:AppleClang>:-fvisibility=hidden>
        $<$<CXX_COMPILER_ID:Clang>:-ftemplate-depth=512>
        $<$<CXX_COMPILER_ID:AppleClang>:-ftemplate-depth=512>
)

if(APPLE)
    set_target_properties(freeorioncommon
        PROPERTIES

=== Empire/CMakeLists.txt ===
target_sources(freeorioncommon
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/Diplomacy.h
        ${CMAKE_CURRENT_LIST_DIR}/Empire.h
        ${CMAKE_CURRENT_LIST_DIR}/EmpireManager.h
        ${CMAKE_CURRENT_LIST_DIR}/PopulationPool.h
        ${CMAKE_CURRENT_LIST_DIR}/ProductionQueue.h
        ${CMAKE_CURRENT_LIST_DIR}/ResearchQueue.h
        ${CMAKE_CURRENT_LIST_DIR}/ResourcePool.h
        ${CMAKE_CURRENT_LIST_DIR}/Supply.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/Diplomacy.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Empire.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EmpireManager.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PopulationPool.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ProductionQueue.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ResearchQueue.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ResourcePool.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Supply.cpp
)

=== GG/CMakeLists.txt ===
# GG is a GUI for SDL and OpenGL.
#
# Copyright (C) 2009-2011 T. Zach Laine
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA
#
# If you do not wish to comply with the terms of the LGPL please
# contact the author as other terms are available for a fee.
#
# Zach Laine
# whatwasthataddress@gmail.com

cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

if(POLICY CMP0044)
    cmake_policy(SET CMP0044 OLD)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_HOME_DIRECTORY}/cmake)


##
## Global project configuration
##

project(GiGi)

include(CMakeDependentOption)
include(GNUInstallDirs)
include(UseCodeCoverage)
include(Util)

set(GIGI_VERSION 0.8.0)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

option(ENABLE_PNG_TEXTURES "Enable PNG texture support." ON)
option(ENABLE_TIFF_TEXTURES "Enable TIFF texture support." OFF)
option(BUILD_SDL_DRIVER "Builds GG SDL support (the GiGiSDL library)." ON)
option(BUILD_DOCUMENTATION "Builds HTML documentation." OFF)
option(BUILD_TESTING "Build the testing tree." OFF)
option(BUILD_DEVEL_PACKAGE "Install development files." ON)

cmake_dependent_option(USE_STATIC_LIBS "Favour static linking of depencendies." OFF BUILD_SHARED_LIBS OFF)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})


if(MSVC)
    set(CMAKE_STATIC_LIBRARY_PREFIX "lib")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
    set(CMAKE_STATIC_LINKER_FLAGS "${CMAKE_STATIC_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")

    add_definitions(/wd4146 /wd4099 /wd4251 /wd4800 /wd4267 /wd4275
                    /wd4244 /wd4101 /wd4258 /wd4351 /wd4996)
    add_definitions(
        /EHsc
        -D_UNICODE
    )
endif()


##
## Collect project dependencies.
##

set(MINIMUM_BOOST_VERSION 1.58.0)

if(NOT USE_STATIC_LIBS)
    add_definitions(
        -DBOOST_ALL_NO_LINK
        -DBOOST_ALL_DYN_LINK
        -DBOOST_LOG_DYN_LINK
    )
endif()

set(Boost_USE_STATIC_LIBS ${USE_STATIC_LIBS})
find_package(Boost ${MINIMUM_BOOST_VERSION} COMPONENTS date_time filesystem regex signals system thread log REQUIRED)

find_package(OpenGL REQUIRED)
find_package(GLEW REQUIRED)
find_package(Freetype REQUIRED)

if(NOT OPENGL_GLU_FOUND)
    message(FATAL_ERROR "OpenGL GLU library not found.")
endif()

if(ENABLE_PNG_TEXTURES)
    find_package(PNG REQUIRED)
    set(int_have_png 1)
else()
    set(int_have_png 0)
endif()

if(ENABLE_TIFF_TEXTURES)
    find_package(TIFF REQUIRED)
    set(int_have_tiff 1)
else()
    set(int_have_tiff 0)
endif()
set(SDL_NO_MAIN true)

find_package(SDL REQUIRED)


include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/GG/Config.h
    @ONLY
)


##
## Define main project targets.
##

add_library(GiGi "")

if(USE_STATIC_LIBS)
    set_target_properties(GiGi
        PROPERTIES
        LINK_SEARCH_END_STATIC true
    )
endif()

target_compile_definitions(GiGi
    PRIVATE

        # Starting with boost 1.68 boost::gil integrates support for
        # grayscale-alpha png images, so prefer their implementation
        # instead of our hacky gilext code.
        $<$<VERSION_LESS:${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION},1.68>:GIGI_CONFIG_USE_OLD_IMPLEMENTATION_OF_GIL_PNG_IO>
        $<$<VERSION_GREATER:${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION},1.67>:BOOST_GIL_IO_ENABLE_GRAY_ALPHA>
)

target_include_directories(GiGi SYSTEM
    PRIVATE
        ${Boost_INCLUDE_DIRS}
        ${OPENGL_INCLUDE_DIR}
        ${GLEW_INCLUDE_DIRS}
        ${FREETYPE_INCLUDE_DIRS}
        ${PNG_INCLUDE_DIRS}
        ${TIFF_INCLUDE_DIRS}
)

target_link_libraries(GiGi
    ${Boost_LIBRARIES}
    ${OPENGL_LIBRARIES}
    ${GLEW_LIBRARIES}
    ${FREETYPE_LIBRARIES}
)

if(PNG_FOUND)
    target_link_libraries(GiGi ${PNG_LIBRARIES})
endif()

if(TIFF_FOUND)
    target_link_libraries(GiGi ${TIFF_LIBRARIES})
endif()


add_library(GiGiSDL "")

if(USE_STATIC_LIBS)
    set_target_properties(GiGiSDL
        PROPERTIES
        LINK_SEARCH_END_STATIC true
    )
endif()

target_include_directories(GiGiSDL SYSTEM
    PRIVATE
        ${Boost_INCLUDE_DIRS}
        ${OPENGL_INCLUDE_DIR}
        ${GLEW_INCLUDE_DIRS}
        ${SDL_INCLUDE_DIR}
)

target_link_libraries(GiGiSDL
    GiGi
    ${OPENGL_LIBRARIES}
    ${GLEW_LIBRARIES}
    ${SDL_LIBRARIES}
)


##
## Recurse into sources.
##

add_subdirectory(GG)
add_subdirectory(src)

if(BUILD_TESTING)
    enable_testing()
    enable_coverage()

    if(NOT TARGET unittest)
        add_custom_target(unittest
            COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
            COMMENT "Run tests for ${CMAKE_PROJECT_NAME}"
        )
    endif()

    add_subdirectory(test)
endif()

if(BUILD_DOCUMENTATION)
    add_subdirectory(doc)
endif()


##
## Install targets and package project.
##

if(BUILD_DEVEL_PACKAGE)
    install(
        DIRECTORY GG
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
        COMPONENT COMPONENT_GIGI_DEVEL
    )
endif()

if(UNIX AND NOT APPLE)
    install(
        TARGETS GiGi
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT COMPONENT_GIGI
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        COMPONENT COMPONENT_GIGI
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT COMPONENT_GIGI_DEVEL
    )
endif()

if(UNIX AND BUILD_DEVEL_PACKAGE)
    get_pkg_config_libs(pkg_config_libs ${GiGi_LINK_LIBS})

    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/cmake/GiGi.pc.in
        ${CMAKE_BINARY_DIR}/GiGi.pc
        @ONLY
    )

    install(
        FILES ${CMAKE_BINARY_DIR}/GiGi.pc
        DESTINATION  ${CMAKE_INSTALL_LIBDIR}/pkgconfig
        COMPONENT COMPONENT_GIGI_DEVEL
        OPTIONAL
    )
endif()


if(UNIX AND NOT APPLE)
    install(
        TARGETS GiGiSDL
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT COMPONENT_GIGISDL
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        COMPONENT COMPONENT_GIGISDL
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT COMPONENT_GIGISDL_DEVEL
    )
endif()

if(UNIX AND BUILD_DEVEL_PACKAGE)
    get_pkg_config_libs(pkg_config_libs ${GiGiSDL_LINK_LIBS})

    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/cmake/GiGiSDL.pc.in
        ${CMAKE_BINARY_DIR}/GiGiSDL.pc
        @ONLY
    )

    install(
        FILES ${CMAKE_BINARY_DIR}/GiGiSDL.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
        COMPONENT COMPONENT_GIGI_DEVEL
        OPTIONAL
    )
endif()


set(CPACK_PACKAGE_VERSION ${GIGI_VERSION})
set(CPACK_PACKAGE_VENDOR "T. Zachary Laine")
set(CPACK_PACKAGE_CONTACT ${CPACK_PACKAGE_VENDOR})
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A C++ OpenGL GUI library.")
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/COPYING)
set(CPACK_SYSTEM_NAME ${CMAKE_SYSTEM_NAME})
set(CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME})
set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-${CPACK_SYSTEM_NAME}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-src)

# RPM-specific settings
set(CPACK_RPM_PACKAGE_LICENSE LGPL)
set(CPACK_RPM_PACKAGE_REQUIRES)

list(APPEND CPACK_RPM_PACKAGE_REQUIRES Mesa freetype2)
list(APPEND CPACK_RPM_PACKAGE_REQUIRES gigi=${GIGI_VERSION})

if(BUILD_SDL_DRIVER)
    list(APPEND CPACK_RPM_PACKAGE_REQUIRES SDL>=1.2)
endif()

if(BUILD_DEVEL_PACKAGE)
    list(APPEND CPACK_RPM_PACKAGE_REQUIRES boost-devel>=1.44.0 Mesa-devel freetype2-devel)
    list(APPEND CPACK_RPM_PACKAGE_REQUIRES gigi-devel=${GIGI_VERSION})
endif()

if(BUILD_DEVEL_PACKAGE AND BUILD_SDL_DRIVER)
    list(APPEND CPACK_RPM_PACKAGE_REQUIRES SDL-devel>=1.2)
endif()

# Deb-specific settings
set(CPACK_DEBIAN_PACKAGE_SECTION libs)

set(CPACK_DEBIAN_PACKAGE_DEPENDS "libgl1-mesa-glx | libgl1, libglu1-mesa | libglu, libfreetype6")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, gigi (= ${GIGI_VERSION})")

if(BUILD_SDL_DRIVER)
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libsdl1.2debian (>= 1.2)")
endif()

if(BUILD_DEVEL_PACKAGE)
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "boost-devel (>= 1.44.0), libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, libfreetype6-dev")
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, gigi-dev (= ${GIGI_VERSION})")
endif()

if(BUILD_DEVEL_PACKAGE AND BUILD_SDL_DRIVER)
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libsdl1.2-dev (>= 1.2)")
endif()

if(UNIX)
    set(CPACK_GENERATOR "TGZ;TBZ2")
    find_program(RPMBUILD rpmbuild)
    if(RPMBUILD)
        list(APPEND CPACK_GENERATOR RPM)
    endif()
    set(RPMBUILD ${RPMBUILD} CACHE INTERNAL "")
    find_program(DPKG dpkg)
    if(DPKG)
        list(APPEND CPACK_GENERATOR DEB)
    endif()
    set(DPKG ${DPKG} CACHE INTERNAL "")
    set(CPACK_SOURCE_GENERATOR "TGZ;TBZ2")
elseif(WIN32)
    set(CPACK_GENERATOR "NSIS")
    set(CPACK_SOURCE_GENERATOR "ZIP")
endif()

include(CPack)

cpack_add_component(
    COMPONENT_GIGI
    DISPLAY_NAME GiGi
    DESCRIPTION "The core GG library, including the GUI state machine and all the controls.  Not usable without an input driver."
    REQUIRED
    GROUP COMPONENT_GROUP_RUNTIME
)

cpack_add_component(
    COMPONENT_GIGISDL
    DISPLAY_NAME GiGiSDL
    DESCRIPTION "An SDL input driver (http://www.libsdl.org)."
    GROUP COMPONENT_GROUP_RUNTIME
    DEPENDS COMPONENT_GIGI
)

cpack_add_component(
    COMPONENT_GIGI_DEVEL
    DISPLAY_NAME "GiGi"
    DESCRIPTION "The files necessary to do development with GiGi."
    GROUP COMPONENT_GROUP_DEVEL
    DEPENDS COMPONENT_GIGI
)

cpack_add_component(
    COMPONENT_GIGISDL_DEVEL
    DISPLAY_NAME "GiGiSDL"
    DESCRIPTION "The files necessary to do development with GiGiSDL."
    GROUP COMPONENT_GROUP_DEVEL
    DEPENDS COMPONENT_GIGI_DEVEL COMPONENT_GIGISDL
)

cpack_add_component_group(
    COMPONENT_GROUP_RUNTIME
    DISPLAY_NAME "Runtime"
    DESCRIPTION "The runtime libs needed to run an application that uses GG."
    EXPANDED
)

cpack_add_component_group(
    COMPONENT_GROUP_DEVEL
    DISPLAY_NAME "Development"
    DESCRIPTION "The development libs and headers needed to build an application that uses GG."
    EXPANDED
)

=== UI/CMakeLists.txt ===
add_subdirectory(CombatReport)

target_sources(freeorion
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/About.h
        ${CMAKE_CURRENT_LIST_DIR}/AccordionPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/BuildDesignatorWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/BuildingsPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/CensusBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ChatWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ClientUI.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatLogWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatReportData.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatReportWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/GraphicalSummary.h
        ${CMAKE_CURRENT_LIST_DIR}/CUIControls.h
        ${CMAKE_CURRENT_LIST_DIR}/CUIDrawUtil.h
        ${CMAKE_CURRENT_LIST_DIR}/CUILinkTextBlock.h
        ${CMAKE_CURRENT_LIST_DIR}/CUISlider.h
        ${CMAKE_CURRENT_LIST_DIR}/CUISpin.h
        ${CMAKE_CURRENT_LIST_DIR}/CUIStyle.h
        ${CMAKE_CURRENT_LIST_DIR}/CUIWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/DesignWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/EncyclopediaDetailPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/FieldIcon.h
        ${CMAKE_CURRENT_LIST_DIR}/FleetButton.h
        ${CMAKE_CURRENT_LIST_DIR}/FleetWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/GalaxySetupWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/GraphControl.h
        ${CMAKE_CURRENT_LIST_DIR}/Hotkeys.h
        ${CMAKE_CURRENT_LIST_DIR}/IconTextBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/InGameMenu.h
        ${CMAKE_CURRENT_LIST_DIR}/IntroScreen.h
        ${CMAKE_CURRENT_LIST_DIR}/LinkText.h
        ${CMAKE_CURRENT_LIST_DIR}/MapWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/MeterBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/MilitaryPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/ModeratorActionsWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/MultiIconValueIndicator.h
        ${CMAKE_CURRENT_LIST_DIR}/MultiMeterStatusBar.h
        ${CMAKE_CURRENT_LIST_DIR}/MultiplayerLobbyWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ObjectListWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/OptionsWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/PasswordEnterWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/PlayerListWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/PopulationPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/ProductionWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/QueueListBox.h
        ${CMAKE_CURRENT_LIST_DIR}/ResearchWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ResourceBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ResourcePanel.h
        ${CMAKE_CURRENT_LIST_DIR}/SaveFileDialog.h
        ${CMAKE_CURRENT_LIST_DIR}/ServerConnectWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ShaderProgram.h
        ${CMAKE_CURRENT_LIST_DIR}/SidePanel.h
        ${CMAKE_CURRENT_LIST_DIR}/SitRepPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/Sound.h
        ${CMAKE_CURRENT_LIST_DIR}/SpecialsPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/SystemIcon.h
        ${CMAKE_CURRENT_LIST_DIR}/SystemResourceSummaryBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeArcs.h
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeLayout.h
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/TextBrowseWnd.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/About.cpp
        ${CMAKE_CURRENT_LIST_DIR}/AccordionPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/BuildDesignatorWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/BuildingsPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CensusBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ChatWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ClientUI.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatLogWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatReportData.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatReportWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/GraphicalSummary.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUIControls.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUIDrawUtil.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUILinkTextBlock.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUIStyle.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUIWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/DesignWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EncyclopediaDetailPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FieldIcon.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FleetButton.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FleetWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/GalaxySetupWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/GraphControl.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Hotkeys.cpp
        ${CMAKE_CURRENT_LIST_DIR}/IconTextBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/InGameMenu.cpp
        ${CMAKE_CURRENT_LIST_DIR}/IntroScreen.cpp
        ${CMAKE_CURRENT_LIST_DIR}/LinkText.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MapWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MeterBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MilitaryPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ModeratorActionsWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MultiIconValueIndicator.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MultiMeterStatusBar.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MultiplayerLobbyWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ObjectListWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/OptionsWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PasswordEnterWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PlayerListWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PopulationPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ProductionWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/QueueListBox.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ResearchWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ResourceBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ResourcePanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SaveFileDialog.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ServerConnectWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ShaderProgram.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SidePanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SitRepPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Sound.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SpecialsPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SystemIcon.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SystemResourceSummaryBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeArcs.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeLayout.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TextBrowseWnd.cpp
)

=== check/CMakeLists.txt ===
find_package(CPPCheck)
find_package(PyCodestyle)

if(CPPCHECK_FOUND)
    add_custom_target(check-cpp
        ${CPPCHECK_EXECUTABLE}
            --quiet
            --template=gcc
            --std=c++11
            ${PROJECT_SOURCE_DIR}
        COMMENT "Check C++ for problematic code"
    )
endif()

if(PYCODESTYLE_FOUND)
    configure_file(pep8.ini.in pep8.ini)
    # The script wrapper discards the exit code of `pep8` to allow
    # continuing the build even when there are errors found by `pep8`.
    file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/pep8.cmake"
        "execute_process(
            COMMAND \"${PYCODESTYLE_EXECUTABLE}\" \"--config=${CMAKE_CURRENT_BINARY_DIR}/pep8.ini\"
                \"${PROJECT_SOURCE_DIR}\"
            WORKING_DIRECTORY \"${CMAKE_CURRENT_BINARY_DIR}\")
    ")
    add_custom_target(check-pep8
        "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/pep8.cmake"
        DEPENDS pep8.ini.in
        COMMENT "Check python code for PEP-8 style conformance"
        VERBATIM
        SOURCES pep8.ini.in
    )
endif()

if(NOT TARGET check)
    add_custom_target(check
        COMMENT "Run code quality checks"
    )
endif()

if(CPPCHECK_FOUND)
    add_dependencies(check check-cpp)
endif()

if(PYCODESTYLE_FOUND)
    add_dependencies(check check-pep8)
endif()

=== client/CMakeLists.txt ===
add_subdirectory(AI)
if(NOT BUILD_HEADLESS)
    add_subdirectory(human)
endif()

target_sources(freeorionca
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/ClientApp.h
        ${CMAKE_CURRENT_LIST_DIR}/ClientFSMEvents.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/ClientApp.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ClientFSMEvents.cpp
)

if(NOT BUILD_HEADLESS)
    target_sources(freeorion
        PUBLIC
            ${CMAKE_CURRENT_LIST_DIR}/ClientApp.h
            ${CMAKE_CURRENT_LIST_DIR}/ClientFSMEvents.h
        PRIVATE
            ${CMAKE_CURRENT_LIST_DIR}/ClientApp.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ClientFSMEvents.cpp
    )
endif()

=== network/CMakeLists.txt ===
target_sources(freeorioncommon
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/Message.h
        ${CMAKE_CURRENT_LIST_DIR}/MessageQueue.h
        ${CMAKE_CURRENT_LIST_DIR}/Networking.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/Message.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MessageQueue.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Networking.cpp
)

target_sources(freeoriond
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/ServerNetworking.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/ServerNetworking.cpp
)

target_sources(freeorionca
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/ClientNetworking.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/ClientNetworking.cpp
)

if(NOT BUILD_HEADLESS)
    target_sources(freeorion
        PUBLIC
            ${CMAKE_CURRENT_LIST_DIR}/ClientNetworking.h
        PRIVATE
            ${CMAKE_CURRENT_LIST_DIR}/ClientNetworking.cpp
    )
endif()

=== parse/CMakeLists.txt ===
target_sources(freeorionparseobj
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/Parse.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/CommonParamsParser.h
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser.h
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser1.h
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser2.h
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser3.h
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser4.h
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser5.h
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser6.h
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser7.h
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParserImpl.h
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser.h
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser1.h
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser2.h
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser3.h
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser4.h
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser5.h
        ${CMAKE_CURRENT_LIST_DIR}/EffectParserImpl.h
        ${CMAKE_CURRENT_LIST_DIR}/EnumParser.h
        ${CMAKE_CURRENT_LIST_DIR}/EnumValueRefRules.h
        ${CMAKE_CURRENT_LIST_DIR}/Lexer.h
        ${CMAKE_CURRENT_LIST_DIR}/MovableEnvelope.h
        ${CMAKE_CURRENT_LIST_DIR}/ParseImpl.h
        ${CMAKE_CURRENT_LIST_DIR}/ReportParseError.h
        ${CMAKE_CURRENT_LIST_DIR}/Tokens.h
        ${CMAKE_CURRENT_LIST_DIR}/ValueRefParser.h
        ${CMAKE_CURRENT_LIST_DIR}/ArithmeticRules.cpp
        ${CMAKE_CURRENT_LIST_DIR}/BuildingsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CommonParamsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser1.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser2.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser3.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser4.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser5.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser6.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser7.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/DoubleComplexValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/DoubleValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser1.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser2.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser3.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser4.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser5.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EmpireStatsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EncyclopediaParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EnumParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FieldsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FleetPlansParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/GameRulesParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/IntComplexValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/IntValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ItemsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/KeymapParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Lexer.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MonsterFleetPlansParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Parse.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PlanetEnvironmentValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PlanetSizeValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PlanetTypeValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ReportParseError.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ShipDesignsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ShipHullsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ShipPartsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SpecialsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SpeciesParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/StarTypeValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/StringComplexValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/StringValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TechsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/UniverseObjectTypeValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/VisibilityValueRefParser.cpp
)

=== test/CMakeLists.txt ===
add_subdirectory(parse)
add_subdirectory(util)

=== universe/CMakeLists.txt ===
target_sources(freeorioncommon
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/Building.h
        ${CMAKE_CURRENT_LIST_DIR}/Condition.h
        ${CMAKE_CURRENT_LIST_DIR}/EffectAccounting.h
        ${CMAKE_CURRENT_LIST_DIR}/Effect.h
        ${CMAKE_CURRENT_LIST_DIR}/Encyclopedia.h
        ${CMAKE_CURRENT_LIST_DIR}/Enums.h
        ${CMAKE_CURRENT_LIST_DIR}/Field.h
        ${CMAKE_CURRENT_LIST_DIR}/Fighter.h
        ${CMAKE_CURRENT_LIST_DIR}/Fleet.h
        ${CMAKE_CURRENT_LIST_DIR}/IDAllocator.h
        ${CMAKE_CURRENT_LIST_DIR}/Meter.h
        ${CMAKE_CURRENT_LIST_DIR}/ObjectMap.h
        ${CMAKE_CURRENT_LIST_DIR}/Planet.h
        ${CMAKE_CURRENT_LIST_DIR}/PopCenter.h
        ${CMAKE_CURRENT_LIST_DIR}/Predicates.h
        ${CMAKE_CURRENT_LIST_DIR}/ResourceCenter.h
        ${CMAKE_CURRENT_LIST_DIR}/ShipDesign.h
        ${CMAKE_CURRENT_LIST_DIR}/Ship.h
        ${CMAKE_CURRENT_LIST_DIR}/Special.h
        ${CMAKE_CURRENT_LIST_DIR}/Species.h
        ${CMAKE_CURRENT_LIST_DIR}/System.h
        ${CMAKE_CURRENT_LIST_DIR}/Tech.h
        ${CMAKE_CURRENT_LIST_DIR}/Universe.h
        ${CMAKE_CURRENT_LIST_DIR}/Pathfinder.h
        ${CMAKE_CURRENT_LIST_DIR}/UniverseObject.h
        ${CMAKE_CURRENT_LIST_DIR}/ValueRef.h
        ${CMAKE_CURRENT_LIST_DIR}/ValueRefFwd.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/Building.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Condition.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectAccounting.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Effect.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Encyclopedia.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Enums.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Field.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Fighter.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Fleet.cpp
        ${CMAKE_CURRENT_LIST_DIR}/IDAllocator.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Meter.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ObjectMap.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Planet.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PopCenter.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Predicates.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ResourceCenter.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Ship.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ShipDesign.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Special.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Species.cpp
        ${CMAKE_CURRENT_LIST_DIR}/System.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Tech.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Universe.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Pathfinder.cpp
        ${CMAKE_CURRENT_LIST_DIR}/UniverseObject.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ValueRef.cpp
)

target_sources(freeoriond
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/UniverseGenerator.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/UniverseGenerator.cpp
)

=== GG/GG/CMakeLists.txt ===
# GG is a GUI for SDL and OpenGL.
#
# Copyright (C) 2017 Marcel Metz
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA
#
# If you do not wish to comply with the terms of the LGPL please
# contact the author as other terms are available for a fee.
#
# Zach Laine
# whatwasthataddress@gmail.com

add_subdirectory(dialogs)
add_subdirectory(RichText)

if(BUILD_SDL_DRIVER)
    add_subdirectory(SDL)
endif()

target_sources(GiGi
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/AlignmentFlags.h
        ${CMAKE_CURRENT_LIST_DIR}/Base.h
        ${CMAKE_CURRENT_LIST_DIR}/BrowseInfoWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/Button.h
        ${CMAKE_CURRENT_LIST_DIR}/ClrConstants.h
        ${CMAKE_CURRENT_LIST_DIR}/Clr.h
        ${CMAKE_CURRENT_LIST_DIR}/Config.h
        ${CMAKE_CURRENT_LIST_DIR}/Control.h
        ${CMAKE_CURRENT_LIST_DIR}/Cursor.h
        ${CMAKE_CURRENT_LIST_DIR}/DeferredLayout.h
        ${CMAKE_CURRENT_LIST_DIR}/DrawUtil.h
        ${CMAKE_CURRENT_LIST_DIR}/DropDownList.h
        ${CMAKE_CURRENT_LIST_DIR}/DynamicGraphic.h
        ${CMAKE_CURRENT_LIST_DIR}/Edit.h
        ${CMAKE_CURRENT_LIST_DIR}/Enum.h
        ${CMAKE_CURRENT_LIST_DIR}/EventPump.h
        ${CMAKE_CURRENT_LIST_DIR}/Exception.h
        ${CMAKE_CURRENT_LIST_DIR}/Export.h
        ${CMAKE_CURRENT_LIST_DIR}/Flags.h
        ${CMAKE_CURRENT_LIST_DIR}/FontFwd.h
        ${CMAKE_CURRENT_LIST_DIR}/Font.h
        ${CMAKE_CURRENT_LIST_DIR}/GGFwd.h
        ${CMAKE_CURRENT_LIST_DIR}/GLClientAndServerBuffer.h
        ${CMAKE_CURRENT_LIST_DIR}/GroupBox.h
        ${CMAKE_CURRENT_LIST_DIR}/GUI.h
        ${CMAKE_CURRENT_LIST_DIR}/Layout.h
        ${CMAKE_CURRENT_LIST_DIR}/ListBox.h
        ${CMAKE_CURRENT_LIST_DIR}/Menu.h
        ${CMAKE_CURRENT_LIST_DIR}/MultiEditFwd.h
        ${CMAKE_CURRENT_LIST_DIR}/MultiEdit.h
        ${CMAKE_CURRENT_LIST_DIR}/PtRect.h
        ${CMAKE_CURRENT_LIST_DIR}/Scroll.h
        ${CMAKE_CURRENT_LIST_DIR}/ScrollPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/Slider.h
        ${CMAKE_CURRENT_LIST_DIR}/Spin.h
        ${CMAKE_CURRENT_LIST_DIR}/StaticGraphic.h
        ${CMAKE_CURRENT_LIST_DIR}/StrongTypedef.h
        ${CMAKE_CURRENT_LIST_DIR}/StyleFactory.h
        ${CMAKE_CURRENT_LIST_DIR}/TabWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/TextControl.h
        ${CMAKE_CURRENT_LIST_DIR}/Texture.h
        ${CMAKE_CURRENT_LIST_DIR}/Timer.h
        ${CMAKE_CURRENT_LIST_DIR}/UnicodeCharsets.h
        ${CMAKE_CURRENT_LIST_DIR}/WndEvent.h
        ${CMAKE_CURRENT_LIST_DIR}/Wnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ZList.h
)

=== GG/doc/CMakeLists.txt ===
# GG is a GUI for SDL and OpenGL.
#
# Copyright (C) 2016 Marcel Metz
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA
#
# If you do not wish to comply with the terms of the LGPL please
# contact the author as other terms are available for a fee.
#
# Zach Laine
# whatwasthataddress@gmail.com

find_package(Doxygen REQUIRED)

configure_file(
    Doxyfile.in
    Doxyfile
    @ONLY
)

if(NOT TARGET doc)
    add_custom_target(doc)
endif()

add_custom_command(
    OUTPUT GG/index.html
    COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
    MAIN_DEPENDENCY ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
            ${CMAKE_CURRENT_SOURCE_DIR}/GGDoc.txt
    COMMENT "Generating GiGi API documentation with Doxygen" VERBATIM
)

add_custom_target(GiGi-apidoc DEPENDS GG/index.html)
add_dependencies(doc GiGi-apidoc)

install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/GG
    DESTINATION ${CMAKE_INSTALL_DOCDIR}
    COMPONENT COMPONENT_GIGI_DEVEL
)

=== debian/changelog ===
freeorion (0.4.8-3~mx17+1) mx; urgency=medium

  * Rebuild for MX-17/18.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Mon, 11 Nov 2019 14:41:52 -0800

freeorion (0.4.8-3) unstable; urgency=medium

  * Really fix save or load game crash. (Closes: #930417)

 -- Markus Koschany <apo@debian.org>  Sun, 23 Jun 2019 01:52:26 +0200

freeorion (0.4.8-2) unstable; urgency=medium

  * Fix save or load game crash. Thanks to Michal Mauser for the report and
    Bernhard Übelacker for the investigation. (Closes: #930417)

 -- Markus Koschany <apo@debian.org>  Sun, 16 Jun 2019 01:02:41 +0200

freeorion (0.4.8-1) unstable; urgency=medium

  * New upstream version 0.4.8.
  * Declare compliance with Debian Policy 4.2.1.
  * Remove dpkg-dev from Build-Depends.

 -- Markus Koschany <apo@debian.org>  Fri, 31 Aug 2018 17:09:10 +0200

freeorion (0.4.8~RC2-2) unstable; urgency=medium

  * Replace dh_install --fail-missing with dh_missing --fail-missing.
  * Declare compliance with Debian Policy 4.2.0.
  * Fix memory exhaustion issues on 32bit architectures.
    - less debug info (-g1) on all 32bit architectures except i386
    - optimizing for size instead of speed with -Os (MinSizeRel)
      does not help with this kind of problems, "Release" is
      appropriate to make cmake not overwrite the added -gq
    - build on linux-any
    Thanks to Adrian Bunk for the report and patch. (Closes: #906746)

 -- Markus Koschany <apo@debian.org>  Tue, 21 Aug 2018 19:48:02 +0200

freeorion (0.4.8~RC2-1) unstable; urgency=medium

  * New upstream version 0.4.8~RC2.
  * Switch to compat level 11.
  * Point CCACHE to a writable directory.
  * Declare compliance with Debian Policy 4.1.5.

 -- Markus Koschany <apo@debian.org>  Thu, 02 Aug 2018 04:20:32 +0200

=== debian/control ===
Source: freeorion
Section: games
Priority: optional
Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Markus Koschany <apo@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 11),
 dh-python,
 libalut-dev,
 libboost-all-dev,
 libfreetype6-dev,
 libgl1-mesa-dev,
 libglew-dev,
 libglu1-mesa-dev,
 libjpeg-dev,
 libogg-dev,
 libopenal-dev,
 libpng-dev,
 libsdl2-dev,
 libtiff-dev,
 libvorbis-dev,
 pkg-config,
 python
Standards-Version: 4.2.1
Homepage: http://www.freeorion.org
Vcs-Git: https://anonscm.debian.org/git/pkg-games/freeorion.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/freeorion.git

Package: freeorion
Architecture: linux-any
Depends:
 freeorion-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: turn-based space empire and galactic conquest game
 FreeOrion is a turn-based space empire and galactic conquest (4X) game being
 designed and built by the FreeOrion project. FreeOrion is inspired by the
 tradition of the Master of Orion games, but is not a clone or remake of that
 series or any other game.
 .
 The game is about the construction of a living, breathing universe in a grand
 campaign model. You can develop your own galactic empire and explore new star
 systems with your fleets as one of several unique human or alien species.
 Colonization of new worlds, researching new technology, managing your
 resources and defending your planets against the AI or other human players on
 a galactic scale are your main objectives.

Package: freeorion-data
Architecture: all
Depends:
 fonts-dejavu,
 fonts-roboto-unhinted,
 ${misc:Depends},
 ${python:Depends}
Suggests:
 freeorion
Description: turn-based space empire and galactic conquest game -- data
 FreeOrion is a turn-based space empire and galactic conquest (4X) game being
 designed and built by the FreeOrion project.
 .
 This package provides architecture-independent data files for FreeOrion,
 hundreds of unique designs for in-game icons, ships and planets, many
 different sounds and an immersive music score.
 .
 Also included are in-game descriptions, translations and game scripts.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export CCACHE_DIR=$(CURDIR)/ccache
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

MAX  := 2
TYPE := RelWithDebInfo

ifeq (32,$(DEB_HOST_ARCH_BITS))
ifeq (,$(filter $(DEB_HOST_ARCH), i386))
	MAX  := 1
	TYPE := Release
	export DEB_CFLAGS_MAINT_APPEND = -g1
	export DEB_CXXFLAGS_MAINT_APPEND = -g1
endif
endif

%:
	dh $@ --max-parallel=$(MAX) --with python2

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_DOCUMENTATION=off \
		-DBUILD_TUTORIALS=off \
		-DLIB_SUFFIX=/freeorion \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DCMAKE_BUILD_TYPE=$(TYPE)

#workaround for 'dpkg-shlibdeps: error: couldn't find library libGiGi*.so'
override_dh_shlibdeps:
	LD_LIBRARY_PATH="$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/freeorion:$(LD_LIBRARY_PATH)" dh_shlibdeps

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog.md

override_dh_missing:
	dh_missing --fail-missing

override_dh_install:
	dh_install
	find debian -type d -empty -delete -printf 'removed %p\n'
	$(RM) -v debian/freeorion-data/usr/share/games/freeorion/default/LICENSE* \
		debian/freeorion-data/usr/share/games/freeorion/default/COPYING \
		debian/freeorion-data/usr/share/games/freeorion/default/data/fonts/LICENSE.*

override_dh_python2:
	dh_python2 -pfreeorion-data /usr/share/games

get-orig-source:
	wget https://github.com/freeorion/freeorion/releases/download/v0.4.8/FreeOrion_v0.4.8_2018-08-23.26f16b0_Source.tar.gz

override_dh_strip:
	dh_strip -a --no-automatic-dbgsym
